
/*
 * Abiturrechner der GTS Offenbach
 * Copyright (C) 2013  Sabine Bergmann
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 * */

  import java.awt.Color;
  import java.awt.Container;
  import java.awt.Dimension;
  import java.awt.EventQueue;
  import java.awt.Font;
  import java.awt.event.ActionEvent;
  import java.awt.event.ActionListener;
  import java.awt.event.FocusAdapter;
  import java.awt.event.FocusEvent;
  import java.beans.PropertyChangeEvent;
  import java.beans.PropertyChangeListener;
  import java.io.File;
  import java.io.PrintStream;
  import java.util.ArrayList;
  import java.util.Iterator;
  import java.util.logging.Level;
  import java.util.logging.Logger;
  import javax.swing.DefaultComboBoxModel;
  import javax.swing.GroupLayout;
  import javax.swing.GroupLayout.Alignment;
  import javax.swing.GroupLayout.ParallelGroup;
  import javax.swing.GroupLayout.SequentialGroup;
  import javax.swing.JCheckBox;
  import javax.swing.JComboBox;
  import javax.swing.JFileChooser;
  import javax.swing.JFrame;
  import javax.swing.JLabel;
  import javax.swing.JMenu;
  import javax.swing.JMenuBar;
  import javax.swing.JMenuItem;
  import javax.swing.JPanel;
  import javax.swing.JRadioButton;
  import javax.swing.JScrollPane;
  import javax.swing.JTabbedPane;
  import javax.swing.JTable;
  import javax.swing.JTextArea;
import javax.swing.LayoutStyle;
  import javax.swing.LayoutStyle.ComponentPlacement;
  import javax.swing.ListSelectionModel;
  import javax.swing.UIManager;
  import javax.swing.UIManager.LookAndFeelInfo;
  import javax.swing.UnsupportedLookAndFeelException;
  import javax.swing.table.DefaultTableModel;
  import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumnModel;

  public class Abirechner extends JFrame
  {
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	KursVerwaltung verwaltung = new KursVerwaltung();
  
    Speicherdaten kd = new Speicherdaten();
    private JFileChooser Dateiwahl;
    private JPanel Kurse;
    private JPanel Noten;
    private JLabel abipunktzahl;
    private JTable ausgabetabelle;
    private JMenuItem beenden;
    private JLabel bestanden;
    private JCheckBox checkboxFranz;
    private JCheckBox checkboxKunst;
    private JComboBox comboFach3;
    private JComboBox comboFach4;
    private JComboBox comboFach5;
    private JComboBox comboLK;
    private JComboBox comboTW;
    private JMenu datei;
    private JLabel durchschnittsnote;
    private JLabel gesamtpunktzahl;
    private JLabel ist18mmm;
    private JLabel jLabel1;
    private JLabel jLabel10;
    private JLabel jLabel11;
    private JLabel jLabel12;
    private JLabel jLabel13;
    private JLabel jLabel14;
    private JLabel jLabel15;
    private JLabel jLabel16;
    private JLabel jLabel17;
    private JLabel jLabel18;
    private JLabel jLabel19;
    private JLabel jLabel2;
    private JLabel jLabel20;
    private JLabel jLabel21;
    private JLabel jLabel22;
    private JLabel jLabel23;
    private JLabel jLabel24;
    private JLabel jLabel25;
    private JLabel jLabel26;
    private JLabel jLabel27;
    private JLabel jLabel28;
    private JLabel jLabel3;
    private JLabel jLabel4;
    private JLabel jLabel5;
    private JLabel jLabel6;
    private JLabel jLabel7;
    private JLabel jLabel8;
    private JLabel jLabel9;
    private JMenuBar jMenuBar1;
    private JPanel jPanel1;
    private JPanel jPanel2;
    private JScrollPane jScrollPane1;
    private JScrollPane jScrollPane2;
    private JScrollPane jScrollPane3;
    private JScrollPane jScrollPane4;
    private JScrollPane jScrollPane5;
    private JScrollPane jScrollPane6;
    private JScrollPane jScrollPane7;
    private JTable jTable1;
    private JTextArea jTextArea1;
    private JTextArea jTextArea2;
    private JTextArea jTextArea3;
    private JTextArea jTextArea4;
    private JLabel kombiZulaessig;
    private JMenuItem laden;
    private JComboBox nach1Combo;
    private JComboBox nach2Combo;
    private JComboBox nach3Combo;
    private JRadioButton nachpruef1;
    private JRadioButton nachpruef2;
    private JRadioButton nachpruef3;
    private JComboBox note1Combo;
    private JComboBox note2Combo;
    private JComboBox note3Combo;
    private JComboBox note4Combo;
    private JComboBox note5Combo;
    private JTable notentabelle;
    private JMenu optionen;
    private JTabbedPane pruefung;
    private JLabel punkteGKDisplay;
    private JLabel punkteLKDisplay;
    private JLabel qualifiziert;
    private JRadioButton radioTWGQ1;
    private JRadioButton radioTWGQ2;
    private JRadioButton radioTWGQ3;
    private JRadioButton radioTWGQ4;
    private JMenuItem speichern;
    private JLabel zahlFreiBeleg;
    private JLabel zuBelegendeBelegt;
    private JLabel zugelassen;
    private JLabel zulaessig;
  
    public Abirechner()
    {
      initComponents();
    }
  
    private void initComponents()
    {
      this.Dateiwahl = new JFileChooser();
      this.jScrollPane5 = new JScrollPane();
      this.jTable1 = new JTable();
      this.pruefung = new JTabbedPane();
      this.Kurse = new JPanel();
      this.jLabel1 = new JLabel();
      this.comboLK = new JComboBox();
      this.jLabel2 = new JLabel();
      this.comboTW = new JComboBox();
      this.jLabel3 = new JLabel();
      this.jLabel4 = new JLabel();
      this.jLabel5 = new JLabel();
      this.comboFach3 = new JComboBox();
      this.comboFach4 = new JComboBox();
      this.comboFach5 = new JComboBox();
      this.checkboxKunst = new JCheckBox();
      this.checkboxFranz = new JCheckBox();
      this.radioTWGQ1 = new JRadioButton();
      this.radioTWGQ2 = new JRadioButton();
      this.radioTWGQ3 = new JRadioButton();
      this.radioTWGQ4 = new JRadioButton();
      this.jLabel11 = new JLabel();
      this.jLabel12 = new JLabel();
      this.jLabel13 = new JLabel();
      this.kombiZulaessig = new JLabel();
      this.ist18mmm = new JLabel();
      this.zahlFreiBeleg = new JLabel();
      this.jScrollPane2 = new JScrollPane();
      this.jTextArea1 = new JTextArea();
      this.jScrollPane3 = new JScrollPane();
      this.jTextArea2 = new JTextArea();
      this.Noten = new JPanel();
      this.jScrollPane4 = new JScrollPane();
      this.notentabelle = new JTable();
      this.jLabel6 = new JLabel();
      this.jLabel7 = new JLabel();
      this.jLabel8 = new JLabel();
      this.jLabel9 = new JLabel();
      this.zulaessig = new JLabel();
      this.jLabel10 = new JLabel();
      this.jLabel14 = new JLabel();
     jLabel14.setFont(new Font("DejaVu Sans", Font.ITALIC, 10));
      this.jScrollPane6 = new JScrollPane();
      this.ausgabetabelle = new JTable();
      this.jLabel15 = new JLabel();
      this.punkteLKDisplay = new JLabel();
      this.jLabel16 = new JLabel();
      this.punkteGKDisplay = new JLabel();
      this.jLabel18 = new JLabel();
      this.jLabel17 = new JLabel();
      this.zuBelegendeBelegt = new JLabel();
      this.qualifiziert = new JLabel();
      this.jPanel1 = new JPanel();
      this.jLabel19 = new JLabel();
      this.jLabel20 = new JLabel();
      this.jLabel21 = new JLabel();
      this.jLabel22 = new JLabel();
      this.jLabel23 = new JLabel();
      this.note1Combo = new JComboBox();
      this.note2Combo = new JComboBox();
      this.note3Combo = new JComboBox();
      this.note4Combo = new JComboBox();
      this.note5Combo = new JComboBox();
      this.nachpruef1 = new JRadioButton();
      this.nachpruef2 = new JRadioButton();
      this.nachpruef3 = new JRadioButton();
      this.nach1Combo = new JComboBox();
      this.nach2Combo = new JComboBox();
      this.nach3Combo = new JComboBox();
      this.jLabel24 = new JLabel();
      this.abipunktzahl = new JLabel();
      this.jLabel25 = new JLabel();
      this.zugelassen = new JLabel();
      this.jScrollPane1 = new JScrollPane();
      this.jTextArea3 = new JTextArea();
      this.jLabel27 = new JLabel();
      this.bestanden = new JLabel();
      this.jLabel26 = new JLabel();
      this.gesamtpunktzahl = new JLabel();
      this.jLabel28 = new JLabel();
      this.durchschnittsnote = new JLabel();
      this.jPanel2 = new JPanel();
      this.jScrollPane7 = new JScrollPane();
      this.jTextArea4 = new JTextArea();
      this.jMenuBar1 = new JMenuBar();
      this.datei = new JMenu();
      this.speichern = new JMenuItem();
      this.laden = new JMenuItem();
      this.optionen = new JMenu();
      this.beenden = new JMenuItem();
  
      this.Dateiwahl.setFileFilter(new FileExtensionFilter());
  
      this.jTable1.setModel(new DefaultTableModel(new Object[][] { { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null } }, new String[] { "Title 1", "Title 2", "Title 3", "Title 4" }));
  
      this.jScrollPane5.setViewportView(this.jTable1);
  
      setDefaultCloseOperation(3);
      setTitle("GTS-Abirechner");
  
      this.pruefung.setMaximumSize(new Dimension(580, 400));
      this.pruefung.setPreferredSize(new Dimension(580, 400));
      this.pruefung.addFocusListener(new FocusAdapter() {
        public void focusGained(FocusEvent evt) {
          Abirechner.this.pruefungFocusGained(evt);
        }
      });
      this.Kurse.addFocusListener(new FocusAdapter() {
        public void focusLost(FocusEvent evt) {
          Abirechner.this.KurseFocusLost(evt);
        }
      });
      this.jLabel1.setFont(new Font("Tahoma", 1, 14));
      this.jLabel1.setText("Erster LK:");
  
      this.comboLK.setModel(new DefaultComboBoxModel(new String[] { "D", "M", "E", "N" }));
      this.comboLK.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.comboLKActionPerformed(evt);
        }
      });
      this.jLabel2.setFont(new Font("Tahoma", 1, 14));
      this.jLabel2.setText("TW-LK:");
  
      this.comboTW.setModel(new DefaultComboBoxModel(new String[] { "MB", "ET", "DV" }));
      this.comboTW.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.comboTWActionPerformed(evt);
        }
      });
      this.jLabel3.setFont(new Font("Tahoma", 1, 14));
      this.jLabel3.setText("3. Fach:");
  
      this.jLabel4.setFont(new Font("Tahoma", 1, 14));
      this.jLabel4.setText("4. Fach:");
  
      this.jLabel5.setFont(new Font("Tahoma", 1, 14));
      this.jLabel5.setText("5. Fach:");
  
      this.comboFach3.setModel(new DefaultComboBoxModel(new String[] { "M", "D", "E", "P", "G", "R", "N" }));
      this.comboFach3.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.comboFach3ActionPerformed(evt);
        }
      });
      this.comboFach4.setModel(new DefaultComboBoxModel(new String[] { "M", "D", "E", "P", "G", "R", "N" }));
      this.comboFach4.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.comboFach4ActionPerformed(evt);
        }
      });
      this.comboFach5.setModel(new DefaultComboBoxModel(new String[] { "M", "D", "E", "P", "G", "R", "N", "L", "L*" }));
      this.comboFach5.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.comboFach5ActionPerformed(evt);
        }
      });
      this.checkboxKunst.setText("Kunst");
      this.checkboxKunst.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.checkboxKunstActionPerformed(evt);
        }
      });
      this.checkboxFranz.setText("Französisch");
      this.checkboxFranz.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.checkboxFranzActionPerformed(evt);
        }
      });
      this.radioTWGQ1.setText("TWG 12/1");
      this.radioTWGQ1.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.radioTWGQ1ActionPerformed(evt);
        }
      });
      this.radioTWGQ2.setText("TWG 12/2");
      this.radioTWGQ2.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.radioTWGQ2ActionPerformed(evt);
        }
      });
      this.radioTWGQ3.setText("TWG 13/1");
      this.radioTWGQ3.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.radioTWGQ3ActionPerformed(evt);
        }
      });
      this.radioTWGQ4.setText("TWG 13/2");
      this.radioTWGQ4.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.radioTWGQ4ActionPerformed(evt);
        }
      });
      this.jLabel11.setFont(new Font("Tahoma", 1, 14));
      this.jLabel11.setText("Ist diese Kombination zulässig?");
  
      this.jLabel12.setFont(new Font("Tahoma", 1, 14));
      this.jLabel12.setText("18-Monate-Modell möglich?");
  
      this.jLabel13.setFont(new Font("Tahoma", 1, 14));
      this.jLabel13.setText("Zahl der frei wählbaren Kurse:");
  
      this.kombiZulaessig.setText("nein");
  
      this.ist18mmm.setText("nein");
  
      this.zahlFreiBeleg.setText("-");
  
      this.jTextArea1.setColumns(20);
      this.jTextArea1.setEditable(false);
      this.jTextArea1.setRows(5);
      this.jTextArea1.setText("Ohne Kunst: Mind. 3 TWG-Kurse\nMit Kunst:  Mind. 1 TWG-Kurs\n    dieser ist für\n      MB/ET: TWG 12/1\n      DV:    TWG 12/2\n18-Monate-Modell: Belegen von \n4 TWG-Kursen erforderlich.");
      this.jScrollPane2.setViewportView(this.jTextArea1);
  
      this.jTextArea2.setColumns(20);
      this.jTextArea2.setEditable(false);
      this.jTextArea2.setRows(5);
      this.jTextArea2.setText("D= Deutsch; E= Englisch; M= \nMathe; P= PoWi; G= Geschichte;\nR= Reli/Ethik; N = Physik/\nChemie; L = bes. Lernleistung;\nweitere siehe \"Info\" ");
      this.jScrollPane3.setViewportView(this.jTextArea2);
  
      GroupLayout KurseLayout = new GroupLayout(this.Kurse);
      this.Kurse.setLayout(KurseLayout);
      KurseLayout.setHorizontalGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(KurseLayout.createSequentialGroup().addContainerGap().addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(KurseLayout.createSequentialGroup().addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.jLabel1).addComponent(this.jLabel2).addComponent(this.jLabel4).addComponent(this.jLabel5).addComponent(this.jLabel3)).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.comboFach5, -2, -1, -2).addComponent(this.comboFach4, -2, -1, -2).addComponent(this.comboLK, -2, -1, -2).addComponent(this.comboTW, -2, -1, -2).addComponent(this.comboFach3, -2, -1, -2)).addGap(98, 98, 98).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.checkboxFranz).addComponent(this.checkboxKunst).addGroup(KurseLayout.createSequentialGroup().addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.TRAILING).addComponent(this.radioTWGQ4).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.radioTWGQ3).addComponent(this.radioTWGQ1).addComponent(this.radioTWGQ2))).addGap(18, 18, 18).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.jScrollPane3, -1, 259, 32767).addComponent(this.jScrollPane2, -1, 259, 32767))))).addGroup(KurseLayout.createSequentialGroup().addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.TRAILING).addComponent(this.jLabel12).addComponent(this.jLabel11).addComponent(this.jLabel13)).addGap(18, 18, 18).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.zahlFreiBeleg).addComponent(this.ist18mmm, -1, 321, 32767).addComponent(this.kombiZulaessig)))).addContainerGap()));
  
      KurseLayout.setVerticalGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(KurseLayout.createSequentialGroup().addGap(28, 28, 28).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel1).addComponent(this.comboLK, -2, -1, -2).addComponent(this.checkboxKunst)).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.comboTW, -2, -1, -2).addComponent(this.checkboxFranz).addComponent(this.jLabel2)).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(KurseLayout.createSequentialGroup().addGap(9, 9, 9).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.TRAILING).addGroup(KurseLayout.createSequentialGroup().addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.comboFach3, -2, -1, -2).addComponent(this.jLabel3)).addGap(65, 65, 65).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel5).addComponent(this.comboFach5, -2, -1, -2)).addGap(11, 11, 11)).addComponent(this.jScrollPane2, GroupLayout.Alignment.LEADING, -2, 132, -2))).addGroup(KurseLayout.createSequentialGroup().addGap(18, 18, 18).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.TRAILING).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel4).addComponent(this.comboFach4, -2, -1, -2)).addGroup(KurseLayout.createSequentialGroup().addComponent(this.radioTWGQ1).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.radioTWGQ2).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addComponent(this.radioTWGQ3))).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addComponent(this.radioTWGQ4))).addGap(38, 38, 38).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.jScrollPane3, -2, -1, -2).addGroup(KurseLayout.createSequentialGroup().addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel11).addComponent(this.kombiZulaessig)).addGap(18, 18, 18).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel12).addComponent(this.ist18mmm)).addGap(18, 18, 18).addGroup(KurseLayout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel13).addComponent(this.zahlFreiBeleg)))).addContainerGap(15, 32767)));
  
      this.pruefung.addTab("Kurse", this.Kurse);
  
      this.Noten.addFocusListener(new FocusAdapter() {
        public void focusGained(FocusEvent evt) {
          Abirechner.this.NotenFocusGained(evt);
        }
      });
      this.notentabelle.setBackground(new Color(204, 255, 255));
      this.notentabelle.setModel(new DefaultTableModel(new Object[][] { { new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0) }, { new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0) }, { new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0) }, { new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0), new Integer(0) } }, new String[] { "TW", "D", "E", "F", "K", "TWG", "P", "G", "R", "M", "N", "T", "S" })
      {
        Class[] types = { Integer.class, Integer.class, Integer.class, Integer.class, Integer.class, Integer.class, Integer.class, Integer.class, Integer.class, Integer.class, Integer.class, Integer.class, Integer.class };
  
        public Class getColumnClass(int columnIndex)
        {
          return this.types[columnIndex];
        }
      });
      this.notentabelle.setToolTipText("0");
      this.notentabelle.setColumnSelectionAllowed(true);
      this.notentabelle.setMaximumSize(new Dimension(250, 64));
      this.notentabelle.setRowHeight(24);
      this.notentabelle.setRowSelectionAllowed(false);
      this.notentabelle.setSurrendersFocusOnKeystroke(true);
      this.notentabelle.getTableHeader().setReorderingAllowed(false);
      this.notentabelle.addPropertyChangeListener(new PropertyChangeListener() {
        public void propertyChange(PropertyChangeEvent evt) {
          Abirechner.this.notentabellePropertyChange(evt);
        }
      });
      this.jScrollPane4.setViewportView(this.notentabelle);
      this.notentabelle.getColumnModel().getSelectionModel().setSelectionMode(0);
  
      this.jLabel6.setText("12/1 (Q1)");
  
      this.jLabel7.setText("12/2 (Q2)");
  
      this.jLabel8.setText("13/1 (Q3)");
  
      this.jLabel9.setText("13/2 (Q4)");
  
      this.zulaessig.setFont(new Font("Tahoma", 1, 18));
      this.zulaessig.setText("Deine Fächerkombination ist nicht zulässig. ");
  
      this.jLabel10.setText("Wenn deine Fächerkombination zulässig ist, kannst du hier deine Noten eingeben.");
  
      this.jLabel14.setText("Bitte beachte: Kunst und Französisch werden nicht mitberechnet, wenn du sie nicht gewählt hast.");
  
      this.ausgabetabelle.setModel(new DefaultTableModel(new Object[][] { { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null }, { null, null, null, null } }, new String[] { "Fach", "Eingebracht", "LK/GK", "Alle Punkte" })
      {
        Class[] types = { String.class, String.class, String.class, Integer.class };
  
        boolean[] canEdit = { false, false, false, false };
  
        public Class getColumnClass(int columnIndex)
        {
          return this.types[columnIndex];
        }
  
        public boolean isCellEditable(int rowIndex, int columnIndex) {
          return this.canEdit[columnIndex];
        }
      });
      this.jScrollPane6.setViewportView(this.ausgabetabelle);
  
      this.jLabel15.setFont(new Font("Tahoma", 1, 12));
      this.jLabel15.setText("Punkte LK:");
  
      this.punkteLKDisplay.setFont(new Font("Tahoma", 3, 12));
      this.punkteLKDisplay.setText("00");
  
      this.jLabel16.setFont(new Font("Tahoma", 1, 12));
      this.jLabel16.setText("Punkte GK:");
  
      this.punkteGKDisplay.setFont(new Font("Tahoma", 3, 12));
      this.punkteGKDisplay.setText("00 ");
  
      this.jLabel18.setText("Du brauchst: mind. 80 ");
  
      this.jLabel17.setText("Du brauchst: mind. 120");
  
      this.zuBelegendeBelegt.setFont(new Font("Tahoma", 1, 11));
      this.zuBelegendeBelegt.setText("Zu belegende Kurse NICHT belegt.");
  
      this.qualifiziert.setFont(new Font("Tahoma", 1, 11));
      this.qualifiziert.setText("Damit bist du NOCH NICHT qualifiziert.");
  
      GroupLayout NotenLayout = new GroupLayout(this.Noten);
     NotenLayout.setHorizontalGroup(
     	NotenLayout.createParallelGroup(Alignment.TRAILING)
     		.addGroup(NotenLayout.createSequentialGroup()
     			.addGroup(NotenLayout.createParallelGroup(Alignment.LEADING)
     				.addGroup(NotenLayout.createSequentialGroup()
     					.addContainerGap()
     					.addComponent(zulaessig))
     				.addGroup(NotenLayout.createSequentialGroup()
     					.addContainerGap()
     					.addComponent(jLabel10))
     				.addGroup(NotenLayout.createSequentialGroup()
     					.addContainerGap()
     					.addComponent(jLabel14))
     				.addGroup(NotenLayout.createSequentialGroup()
     					.addGap(17)
     					.addGroup(NotenLayout.createParallelGroup(Alignment.TRAILING)
     						.addComponent(jLabel7)
     						.addComponent(jLabel8)
     						.addComponent(jLabel9)
     						.addComponent(jLabel6))
     					.addPreferredGap(ComponentPlacement.RELATED)
     					.addComponent(jScrollPane4, GroupLayout.PREFERRED_SIZE, 479, GroupLayout.PREFERRED_SIZE))
     				.addGroup(NotenLayout.createSequentialGroup()
     					.addContainerGap()
     					.addGroup(NotenLayout.createParallelGroup(Alignment.LEADING)
     						.addGroup(NotenLayout.createSequentialGroup()
     							.addComponent(jLabel15)
     							.addPreferredGap(ComponentPlacement.UNRELATED)
     							.addComponent(punkteLKDisplay, GroupLayout.PREFERRED_SIZE, 25, GroupLayout.PREFERRED_SIZE))
     						.addComponent(jLabel18))
     					.addGap(18)
     					.addGroup(NotenLayout.createParallelGroup(Alignment.LEADING, false)
     						.addGroup(NotenLayout.createSequentialGroup()
     							.addComponent(jLabel16)
     							.addPreferredGap(ComponentPlacement.UNRELATED)
     							.addComponent(punkteGKDisplay, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
     						.addComponent(jLabel17))
     					.addGap(18)
     					.addGroup(NotenLayout.createParallelGroup(Alignment.LEADING)
     						.addComponent(qualifiziert)
     						.addComponent(zuBelegendeBelegt)))
     				.addGroup(NotenLayout.createSequentialGroup()
     					.addContainerGap()
     					.addComponent(jScrollPane6, GroupLayout.PREFERRED_SIZE, 563, GroupLayout.PREFERRED_SIZE)))
     			.addGap(25))
     );
     NotenLayout.setVerticalGroup(
     	NotenLayout.createParallelGroup(Alignment.TRAILING)
     		.addGroup(NotenLayout.createSequentialGroup()
     			.addGap(11)
     			.addComponent(zulaessig)
     			.addPreferredGap(ComponentPlacement.UNRELATED)
     			.addComponent(jLabel10)
     			.addPreferredGap(ComponentPlacement.RELATED)
     			.addComponent(jLabel14)
     			.addGroup(NotenLayout.createParallelGroup(Alignment.LEADING)
     				.addGroup(NotenLayout.createSequentialGroup()
     					.addGap(40)
     					.addComponent(jLabel6)
     					.addPreferredGap(ComponentPlacement.UNRELATED)
     					.addComponent(jLabel7)
     					.addPreferredGap(ComponentPlacement.UNRELATED)
     					.addComponent(jLabel8)
     					.addPreferredGap(ComponentPlacement.UNRELATED)
     					.addComponent(jLabel9))
     				.addGroup(NotenLayout.createSequentialGroup()
     					.addPreferredGap(ComponentPlacement.UNRELATED)
     					.addComponent(jScrollPane4, GroupLayout.PREFERRED_SIZE, 127, GroupLayout.PREFERRED_SIZE)))
     			.addPreferredGap(ComponentPlacement.UNRELATED)
     			.addGroup(NotenLayout.createParallelGroup(Alignment.BASELINE)
     				.addComponent(jLabel15)
     				.addComponent(punkteLKDisplay)
     				.addComponent(jLabel16)
     				.addComponent(punkteGKDisplay)
     				.addComponent(zuBelegendeBelegt))
     			.addPreferredGap(ComponentPlacement.RELATED)
     			.addGroup(NotenLayout.createParallelGroup(Alignment.BASELINE)
     				.addComponent(jLabel18)
     				.addComponent(jLabel17)
     				.addComponent(qualifiziert))
     			.addGap(103))
     		.addGroup(NotenLayout.createSequentialGroup()
     			.addContainerGap(276, Short.MAX_VALUE)
     			.addComponent(jScrollPane6, GroupLayout.PREFERRED_SIZE, 89, GroupLayout.PREFERRED_SIZE)
     			.addContainerGap())
     );
      this.Noten.setLayout(NotenLayout);
  
      this.pruefung.addTab("Noten", this.Noten);
  
      this.jLabel19.setText("1. Prüfungsfach:");
  
      this.jLabel20.setText("2. Prüfungsfach:");
  
      this.jLabel21.setText("3. Prüfungsfach:");
  
      this.jLabel22.setText("4. Prüfungsfach:");
  
      this.jLabel23.setText("5. Prüfungsfach:");
  
      this.note1Combo.setModel(new DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
      this.note1Combo.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.note1ComboActionPerformed(evt);
        }
      });
      this.note2Combo.setModel(new DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
      this.note2Combo.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.note2ComboActionPerformed(evt);
        }
      });
      this.note3Combo.setModel(new DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
      this.note3Combo.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.note3ComboActionPerformed(evt);
        }
      });
      this.note4Combo.setModel(new DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
      this.note4Combo.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.note4ComboActionPerformed(evt);
        }
      });
      this.note5Combo.setModel(new DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
      this.note5Combo.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.note5ComboActionPerformed(evt);
        }
      });
      this.nachpruef1.setText("Nachprüfung?");
      this.nachpruef1.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.nachpruef1ActionPerformed(evt);
        }
      });
      this.nachpruef2.setText("Nachprüfung?");
      this.nachpruef2.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.nachpruef2ActionPerformed(evt);
        }
      });
      this.nachpruef3.setText("Nachprüfung?");
      this.nachpruef3.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.nachpruef3ActionPerformed(evt);
        }
      });
      this.nach1Combo.setModel(new DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
      this.nach1Combo.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.nach1ComboActionPerformed(evt);
        }
      });
      this.nach2Combo.setModel(new DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
      this.nach2Combo.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.nach2ComboActionPerformed(evt);
        }
      });
      this.nach3Combo.setModel(new DefaultComboBoxModel(new String[] { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15" }));
      this.nach3Combo.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.nach3ComboActionPerformed(evt);
        }
      });
      this.jLabel24.setFont(new Font("Tahoma", 1, 14));
      this.jLabel24.setText("Erreichte Punktzahl:");
  
      this.abipunktzahl.setFont(new Font("Tahoma", 3, 14));
      this.abipunktzahl.setText("00");
  
      this.jLabel25.setText("Wenn du zur Prüfung zugelassen bist, kannst du hier deine Noten eingeben.");
  
      this.zugelassen.setFont(new Font("Tahoma", 1, 14));
      this.zugelassen.setText("Du bist nicht zugelassen.");
  
      this.jTextArea3.setColumns(20);
      this.jTextArea3.setEditable(false);
      this.jTextArea3.setRows(5);
      this.jTextArea3.setText("Nach einer schriftlichen Prüfung kannst du noch eine\nmündliche ablegen, um deine Note zu verbessern.\nDas Ergebnis dieser Prüfung geht auf jeden Fall ins\nAbitur ein.");
      this.jScrollPane1.setViewportView(this.jTextArea3);
  
      this.jLabel27.setText("von mindestens 100 und maximal 300");
  
      this.bestanden.setFont(new Font("Tahoma", 1, 14));
      this.bestanden.setText("Damit hast du nicht bestanden.");
  
      this.jLabel26.setFont(new Font("Tahoma", 1, 14));
      this.jLabel26.setText("Gesamtpunktzahl:");
  
      this.gesamtpunktzahl.setFont(new Font("Tahoma", 3, 14));
      this.gesamtpunktzahl.setText("00");
  
      this.jLabel28.setFont(new Font("Tahoma", 1, 14));
      this.jLabel28.setText("Deine Durchschnittsnote:");
  
      this.durchschnittsnote.setFont(new Font("Tahoma", 3, 14));
      this.durchschnittsnote.setText("4.0");
  
      GroupLayout jPanel1Layout = new GroupLayout(this.jPanel1);
      this.jPanel1.setLayout(jPanel1Layout);
      jPanel1Layout.setHorizontalGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createSequentialGroup().addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createSequentialGroup().addGap(28, 28, 28).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createSequentialGroup().addComponent(this.jLabel19).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.note1Combo, -2, -1, -2).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.nachpruef1).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.nach1Combo, -2, -1, -2).addGap(18, 18, 18).addComponent(this.zugelassen)).addGroup(jPanel1Layout.createSequentialGroup().addComponent(this.jLabel20).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.note2Combo, -2, -1, -2).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.nachpruef2).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.nach2Combo, -2, -1, -2)).addGroup(jPanel1Layout.createSequentialGroup().addComponent(this.jLabel21).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.note3Combo, -2, -1, -2).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.nachpruef3).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.nach3Combo, -2, -1, -2)).addGroup(jPanel1Layout.createSequentialGroup().addComponent(this.jLabel26).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addComponent(this.gesamtpunktzahl, -2, 70, -2).addGap(18, 18, 18).addComponent(this.bestanden)).addGroup(jPanel1Layout.createSequentialGroup().addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createSequentialGroup().addComponent(this.jLabel22).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.note4Combo, -2, -1, -2)).addGroup(jPanel1Layout.createSequentialGroup().addComponent(this.jLabel23).addPreferredGap(LayoutStyle.ComponentPlacement.RELATED).addComponent(this.note5Combo, -2, -1, -2))).addGap(40, 40, 40).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addComponent(this.jLabel27).addGroup(jPanel1Layout.createSequentialGroup().addComponent(this.jLabel24).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addComponent(this.abipunktzahl, -1, 235, 32767)))).addGroup(jPanel1Layout.createSequentialGroup().addComponent(this.jLabel28).addGap(18, 18, 18).addComponent(this.durchschnittsnote, -2, 32, -2)))).addGroup(jPanel1Layout.createSequentialGroup().addContainerGap().addComponent(this.jLabel25)).addGroup(jPanel1Layout.createSequentialGroup().addContainerGap().addComponent(this.jScrollPane1, -2, 442, -2))).addContainerGap()));
  
      jPanel1Layout.setVerticalGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createSequentialGroup().addContainerGap().addComponent(this.jLabel25).addGap(17, 17, 17).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel19).addComponent(this.note1Combo, -2, -1, -2).addComponent(this.nachpruef1).addComponent(this.nach1Combo, -2, -1, -2).addComponent(this.zugelassen)).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel20).addComponent(this.note2Combo, -2, -1, -2).addComponent(this.nachpruef2).addComponent(this.nach2Combo, -2, -1, -2)).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel21).addComponent(this.note3Combo, -2, -1, -2).addComponent(this.nachpruef3).addComponent(this.nach3Combo, -2, -1, -2)).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createSequentialGroup().addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel22).addComponent(this.note4Combo, -2, -1, -2)).addPreferredGap(LayoutStyle.ComponentPlacement.UNRELATED).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel23).addComponent(this.note5Combo, -2, -1, -2).addComponent(this.jLabel27))).addGroup(jPanel1Layout.createSequentialGroup().addGap(20, 20, 20).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel24).addComponent(this.abipunktzahl)))).addGap(18, 18, 18).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel26).addComponent(this.gesamtpunktzahl)).addComponent(this.bestanden)).addGap(11, 11, 11).addGroup(jPanel1Layout.createParallelGroup(GroupLayout.Alignment.BASELINE).addComponent(this.jLabel28).addComponent(this.durchschnittsnote)).addGap(18, 18, 18).addComponent(this.jScrollPane1, -1, 93, 32767).addContainerGap()));
  
      this.pruefung.addTab("Prüfung", this.jPanel1);
  
      this.jTextArea4.setColumns(20);
      this.jTextArea4.setRows(5);
      this.jTextArea4.setText("________________________________________________________________\nVerwendete Abkürzungen:\n\nD= Deutsch; E= Englisch; M= Mathematik; P= PoWi; G= Geschichte;\nR= Reli/Ethik; N = Physik/Chemie; L = bessondere Lernleistung \nL* = besondere Lernleistung aus dem 2. Aufgabenfeld;\nTW = Technikwissenschaft (LK); TWG = Technikwissenschaft Grund-\nkurs; TG = Technologie;\nET = Elektrotechnik; MB = Maschinenbau; DV = Datenverarbeitung;\n________________________________________________________________\n\nDen GTS-Abirechner kannst Du ab Ende der Klasse 11 bis zu den\nAbiturprüfungen sinnvoll nutzen.\n\nÜber den Menü-Punkt \"Datei\" kannst Du \"Speichern\" und \"Laden\"\nwählen. Damit kannst Du Deine Eingaben im Abirechner speichern\nund auch wieder laden, sodass Du nicht immer alles neu eingeben\nmusst.\n\n***Wie nutze ich den Abirechner nun?***\n\nDu kannst ihn ganz \"ordnungsgemäß\" nutzen: Über den Tab Kurse be-\nstimmen, welche Wahl von Leistungskursen und Prüfungsfächern zu-\nlässig ist, danach mit jedem Zeugnis Deine Punkte im Tab \"Noten\"\neintragen und schließlich die Ergebnisse Deiner Abiturprüfungen.\nSo siehst Du immer, wie viele Punkte Dir noch zu Deinen Zielen\nfehlen.\n\nGenauso vorzuschlagen ist aber das \"Herumprobieren\" - Welche\nKombinationen sind möglich? Bei welcher Kombination von Prüfungs-\nfächern und Noten bekomme ich die meisten Punkte? Wieviel Punkte\nmuss ich für einen bestimmten Notenschnitt erreichen?\n\nLies Dir am Besten die unten stehenden Informationen durch, und\nteste danach nach Belieben herum. \nZu empfehlen ist, dass Du Dir eine Datei erstellst, in der Du\nDeine realen Belegungen und Noten speicherst, d.h. sie eingibst,\neine Datei speicherst, und diese regelmäßig lädst und \naktualisierst. So behälst Du deinen Stand immer im Blick.\n\n***Wie setzt sich die Abiturnote zusammen?***\n\nDu belegst ab der 12. Klasse Grund- und Leistungskurse. Einer\nDeiner Leistungskurse ist TW (Datenverarbeitung, Maschinenbau\noder Elektrotechnik), der andere Mathematik, Deutsch, Englisch\noder eine Naturwissenschaft (Physik oder Chemie).\n\nJedes Halbjahr in einem Fach wird als Kurs bezeichnet. Das Halb-\njahr 12/1 heißt Q1, 12/2 Q2, 13/1 Q3 und 13/2 Q4.\n \nIn Deinen Leistungsfächern müssen alle 4 Kurse belegt werden, d.h.\nmit über 0 Punkten abgeschlossen (wenn Du hingehst, aber 0 Punkte\nhast, gilt der Kurs als nicht belegt). \nIn Deinen Grundfächern muss ebenfalls je eine bestimmte Zahl von\nKursen belegt werden.\n\nDabei gehen alle Punkte der Leistungskurse ins Abitur ein. Sie\nwerden sie jeweils doppelt gewertet.\n24 Grundkurse müssen ebenfalls ins Abitur eingebracht werden. \nDabei gibt es wieder einige Verordnungen, welche Kurse einge-\nbracht werden müssen. Manchmal sind es einfach z.B. 2 von 4, oder\nes sind etwa Q3 und Q4. Nachdem Du alle Kurse zusammenzählst,\ndie Du einbringen musst, ist die 24 nicht immer erreicht. Du\nmusst also noch weitere Kurse einbringen - aus denen, die Du \nnicht zwangsläufig einbringen musst. \nDas sind Deine freien Kurse. Hier wählst Du natürlich Deine \nBesten.\n\nAlle Punktzahlen, die Du in den Abiturprüfungen erreichst, \nwerden ins Abitur eingebracht. Du darfst natürlich keine Abitur-\nprüfung mit 0 Punkten abschließen, und drei müssen mit 5 oder\nmehr Punkten abgeschlossen werden. \n\nAus Deiner erreichten Gesamtpunktzahl errechnet sich Deine\nAbiturnote:\nGesamtpunktzahl=2*(Punkte der LK)+1*(Punkte der GK)+4*(Punkte \n                 aus den Prüfungen)\n\nDer Abirechner hilft Dir, Deine Noten zu berechnen und richtig zu\nwählen, welche Deiner freien Kurse Du einbringst.\n\n\n***Informationen zum Tab Kurse***\n\nHier kannst du herausfinden, welche Kombinationen von Fächern Du \nals Prüfungsfächer wählen kannst - das ist wichtig bei\nder Wahl Deiner Leistungskurse in Klasse 11 und bei Deiner Wahl \ndes 3., 4. und 5. Prüfungsfaches in Klasse 12.\n\nDu kannst hier zwei Leistungskurse wählen. Einer davon ist immer\nTW - suche hier aus, welche Technikwissenschaft du belegst. Der\nandere ist Mathematik, Deutsch, Englisch oder eine Naturwissen-\nschaft (Physik oder Chemie).\n\nZudem kannst Du hier deine 3 Grundkurse wählen, zu denen Du eine\nAbiturprüfung ablegen wirst. Als 5. Prüfungsfach ist auch eine\nbesondere Lernleistung möglich.\n\nDu kannst wählen, ob Du Kunst oder Französisch belegst und welche\nTWG-Kurse Du belegen willst. Angaben dazu befinden sich neben den\nButtons. \n\nWenn Deine Kombination zulässig ist, wird Dir das angezeigt. \n\nProbiere also durch Klicken, welche Deiner Kombinationen\nzulässig ist. \n\n***Informationen zum Tab Noten***\n\nHier kannst Du deine Noten für die jeweiligen Kurse eingeben.\nKompakt wird Dir angezeigt, wieviele Punkte (zweifach gerechnet)\nDu in den Leistungsfächern erhälst, und wieviele in den einge-\nbrachten Grundkursen.\nDer Abirechner bringt dabei Deine besten Grundkurse automatisch\nein!\nIn der Tabelle unten kannst Du schauen, wieviele Punkte Du\nin einem belegten Fach jeweils erzielt hast, und welche Kurse\ndort eingebracht wurden. Dies ist die bestmögliche Wahl Deiner\nfreien Kurse, Du solltest sie so einbringen.\n\n***Informationen zum Tab Prüfung*\n\nHier kannst Du Deine Prüfungsnoten eingeben und deine Ergebnisse\nerhalten. \nSolange Du nicht zugelassen bist, wird Dir immer wieder \nausgegeben werden, dass Du nicht bestanden hast! Es nutzt also\nnichts, wenn Du im Tab Noten nichts eingibst, oder keine zu-\nlässigen Kurse wählst, und dann im Prüfungs-Tab schauen gehst,\nmit welchen Prüfungsergebnissen Du noch durchs Abi kommst. Das\nkannst Du dennoch tun, indem Du einfach nur auf die Zahl der\nPunkte achtest. Der Abirechner ist so programmiert, dass Dir die\nerreichten Punkte auch angezeigt werden, wenn Du nicht zugelassen\nbist. Ignoriere für diesen \"Herumprobieren\" einfach die Ausgabe,\nDu hättest nicht bestanden.\nAllerdings solltest Du dann beachten, dass Du nicht nur über 100\nPunkte erreichen musst, sondern auch mindestens 3 Prüfungen, \ndavon eine in einem LK, mit mindestens 5 Punkten bestehen musst.\nDies bekommst Du nicht explizit mitgeteilt.\n");
      this.jScrollPane7.setViewportView(this.jTextArea4);
  
      GroupLayout jPanel2Layout = new GroupLayout(this.jPanel2);
      this.jPanel2.setLayout(jPanel2Layout);
      jPanel2Layout.setHorizontalGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel2Layout.createSequentialGroup().addContainerGap().addComponent(this.jScrollPane7, -2, 547, -2).addContainerGap(18, 32767)));
  
      jPanel2Layout.setVerticalGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(jPanel2Layout.createSequentialGroup().addContainerGap().addComponent(this.jScrollPane7, -1, 350, 32767).addContainerGap()));
  
      this.pruefung.addTab("Info", this.jPanel2);
  
      this.datei.setText("Datei");
  
      this.speichern.setText("Speichern");
      this.speichern.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.speichernActionPerformed(evt);
        }
      });
      this.datei.add(this.speichern);
  
      this.laden.setText("Laden");
      this.laden.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.ladenActionPerformed(evt);
        }
      });
      this.datei.add(this.laden);
  
      this.jMenuBar1.add(this.datei);
  
      this.optionen.setText("Optionen");
  
      this.beenden.setText("Beenden");
      this.beenden.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          Abirechner.this.beendenActionPerformed(evt);
        }
      });
      this.optionen.add(this.beenden);
  
      this.jMenuBar1.add(this.optionen);
  
      setJMenuBar(this.jMenuBar1);
  
      GroupLayout layout = new GroupLayout(getContentPane());
      getContentPane().setLayout(layout);
      layout.setHorizontalGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addComponent(this.pruefung, -2, -1, -2).addContainerGap(14, 32767)));
  
      layout.setVerticalGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING).addGroup(layout.createSequentialGroup().addComponent(this.pruefung, -2, -1, -2).addContainerGap(-1, 32767)));
  
      pack();
    }
  
    private void beendenActionPerformed(ActionEvent evt)
    {
      System.exit(0);
    }
  
    private void speichernActionPerformed(ActionEvent evt)
    {
      this.Dateiwahl.showSaveDialog(this.speichern);
      File f = this.Dateiwahl.getSelectedFile();
      Dateioperationen myDat = new Dateioperationen();
      setKursdaten(); setNotendaten(); setPruefungsdaten();
      myDat.serializeLeseInDatei(this.kd, f);
    }
  
    private void ladenActionPerformed(ActionEvent evt)
    {
      int returnVal = this.Dateiwahl.showOpenDialog(null);
      if (returnVal == 0)
      {
        File f = this.Dateiwahl.getSelectedFile();
        try
        {
          Dateioperationen myDat = new Dateioperationen();
          Speicherdaten temp = myDat.deserializeLeseAusDatei(f);
          this.kd = temp;
          getKursdaten(); getNotendaten(); getPruefungsdaten();
        } catch (Exception ex) {
        }
      }
    }
  
    private void comboLKActionPerformed(ActionEvent evt) {
      this.verwaltung.setLkfach1((String)this.comboLK.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboLKActionPerformed()
    {
      this.verwaltung.setLkfach1((String)this.comboLK.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboTWActionPerformed(ActionEvent evt)
    {
      this.verwaltung.setLkfachTW((String)this.comboTW.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboTWActionPerformed()
    {
      this.verwaltung.setLkfachTW((String)this.comboTW.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboFach3ActionPerformed(ActionEvent evt)
    {
      this.verwaltung.setPruef3((String)this.comboFach3.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboFach3ActionPerformed()
    {
      this.verwaltung.setPruef3((String)this.comboFach3.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboFach4ActionPerformed(ActionEvent evt)
    {
      this.verwaltung.setPruef4((String)this.comboFach4.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboFach4ActionPerformed()
    {
      this.verwaltung.setPruef4((String)this.comboFach4.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboFach5ActionPerformed(ActionEvent evt)
    {
      this.verwaltung.setPruef5((String)this.comboFach5.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void comboFach5ActionPerformed()
    {
      this.verwaltung.setPruef5((String)this.comboFach5.getSelectedItem());
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void checkboxKunstActionPerformed(ActionEvent evt)
    {
      Boolean b = Boolean.valueOf(this.checkboxKunst.isSelected());
      this.verwaltung.setKunst(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void checkboxKunstActionPerformed()
    {
      Boolean b = Boolean.valueOf(this.checkboxKunst.isSelected());
      this.verwaltung.setKunst(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void checkboxFranzActionPerformed(ActionEvent evt)
    {
      Boolean b = Boolean.valueOf(this.checkboxFranz.isSelected());
      this.verwaltung.setFranz(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void checkboxFranzActionPerformed()
    {
      Boolean b = Boolean.valueOf(this.checkboxFranz.isSelected());
      this.verwaltung.setFranz(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void radioTWGQ1ActionPerformed(ActionEvent evt)
    {
      Boolean b = Boolean.valueOf(this.radioTWGQ1.isSelected());
      this.verwaltung.setTwgQ1(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void radioTWGQ1ActionPerformed()
    {
      Boolean b = Boolean.valueOf(this.radioTWGQ1.isSelected());
      this.verwaltung.setTwgQ1(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void radioTWGQ2ActionPerformed(ActionEvent evt)
    {
      Boolean b = Boolean.valueOf(this.radioTWGQ2.isSelected());
      this.verwaltung.setTwgQ2(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void radioTWGQ2ActionPerformed()
    {
      Boolean b = Boolean.valueOf(this.radioTWGQ2.isSelected());
      this.verwaltung.setTwgQ2(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void radioTWGQ3ActionPerformed(ActionEvent evt)
    {
      Boolean b = Boolean.valueOf(this.radioTWGQ3.isSelected());
      this.verwaltung.setTwgQ3(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void radioTWGQ3ActionPerformed()
    {
      Boolean b = Boolean.valueOf(this.radioTWGQ3.isSelected());
      this.verwaltung.setTwgQ3(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void radioTWGQ4ActionPerformed(ActionEvent evt)
    {
      Boolean b = Boolean.valueOf(this.radioTWGQ4.isSelected());
      this.verwaltung.setTwgQ4(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void radioTWGQ4ActionPerformed()
    {
      Boolean b = Boolean.valueOf(this.radioTWGQ4.isSelected());
      this.verwaltung.setTwgQ4(b);
  
      Boolean erlaubt = Boolean.valueOf(this.verwaltung.abiKombiErlaubt());
      Boolean m18mm = Boolean.valueOf(this.verwaltung.m18mm());
      Integer freieKurse = Integer.valueOf(this.verwaltung.freieKurse());
      if (erlaubt.booleanValue()) this.kombiZulaessig.setText("ja");
      if (!erlaubt.booleanValue()) this.kombiZulaessig.setText("nein");
      if (m18mm.booleanValue()) this.ist18mmm.setText("ja");
      if (!m18mm.booleanValue()) this.ist18mmm.setText("nein");
      if (freieKurse.intValue() > -1) this.zahlFreiBeleg.setText(freieKurse.toString());
      if (freieKurse.intValue() <= -1) this.zahlFreiBeleg.setText("-");
  
      notentabelleAktionen();
    }
  
    private void kurstabAktionen()
    {
      comboLKActionPerformed();
      comboTWActionPerformed();
      comboFach3ActionPerformed();
      comboFach4ActionPerformed();
      comboFach5ActionPerformed();
      checkboxKunstActionPerformed();
      checkboxFranzActionPerformed();
      radioTWGQ1ActionPerformed();
      radioTWGQ2ActionPerformed();
      radioTWGQ3ActionPerformed();
      radioTWGQ4ActionPerformed();
    }
  
    private void notentabellePropertyChange(PropertyChangeEvent evt)
    {
      notentabelleAktionen();
    }
  
    private boolean pruefeLK(String fachname)
    {
      String lk = (String)this.comboLK.getSelectedItem();
      if (fachname.equals(lk)) return true;
      if (!fachname.equals(lk)) return false;
      return false;
    }
  
    private boolean pruefeAbiGk(String fachname) {
      String abi3 = (String)this.comboFach3.getSelectedItem();
      String abi4 = (String)this.comboFach4.getSelectedItem();
      String abi5 = (String)this.comboFach5.getSelectedItem();
      String pruef345 = abi3 + abi4 + abi5;
      if (pruef345.contains(fachname)) return true;
      if (!pruef345.contains(fachname)) return false;
      return false;
    }
  
    private void notentabelleAktionen()
    {
      if (this.verwaltung.abiKombiErlaubt())
      {
        this.zulaessig.setText("Deine Fächerkombination ist zulässig.");
        this.notentabelle.setVisible(true);
      }
      if (!this.verwaltung.abiKombiErlaubt())
      {
        this.zulaessig.setText("Deine Fächerkombination ist nicht zulässig.");
        this.notentabelle.setVisible(false);
        return;
      }
  
      this.verwaltung.setzeAlleFaecher();
  
      String f = "D"; int col = 1;
      Integer i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      Kurs q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      Kurs q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      Kurs q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      Kurs q4 = new Kurs(i, 4, f);
      this.verwaltung.deutsch.isLk = pruefeLK(f);
      this.verwaltung.deutsch.isAbiGk = pruefeAbiGk(f);
      this.verwaltung.deutsch.setKurseUsage(q1, q2, q3, q4);
  
      f = "E"; col = 2;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
      this.verwaltung.englisch.isLk = pruefeLK(f);
      this.verwaltung.englisch.isAbiGk = pruefeAbiGk(f);
      this.verwaltung.englisch.setKurseUsage(q1, q2, q3, q4);
  
      f = "F"; col = 3;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
  
      this.verwaltung.franzFach.setKurseUsage(q1, q2, q3, q4);
  
      f = "K"; col = 4;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
  
      this.verwaltung.kunstFach.setKurseUsage(q1, q2, q3, q4);
  
      f = "P"; col = 6;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
  
      this.verwaltung.powi.isAbiGk = pruefeAbiGk(f);
      this.verwaltung.powi.setKurseUsage(q1, q2, q3, q4);
  
      f = "G"; col = 7;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
  
      this.verwaltung.geschichte.isAbiGk = pruefeAbiGk(f);
      this.verwaltung.geschichte.setKurseUsage(q1, q2, q3, q4);
  
      f = "R"; col = 8;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
  
      this.verwaltung.relieth.isAbiGk = pruefeAbiGk(f);
      this.verwaltung.relieth.setKurseUsage(q1, q2, q3, q4);
  
      f = "M"; col = 9;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
      this.verwaltung.mathe.isLk = pruefeLK(f);
      this.verwaltung.mathe.isAbiGk = pruefeAbiGk(f);
      this.verwaltung.mathe.setKurseUsage(q1, q2, q3, q4);
  
      f = "N"; col = 10;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
      this.verwaltung.phychem.isLk = pruefeLK(f);
      this.verwaltung.phychem.isAbiGk = pruefeAbiGk(f);
      this.verwaltung.phychem.setKurseUsage(q1, q2, q3, q4);
  
      f = "T"; col = 11;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
      this.verwaltung.techTG.setKurseUsage(q1, q2, q3, q4);
  
      f = "TW"; col = 0;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
      this.verwaltung.techTW.isLk = true;
      this.verwaltung.techTW.setKurseUsage(q1, q2, q3, q4);
  
      f = "TWG"; col = 5;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
      this.verwaltung.techTWG.setKurseUsage(q1, q2, q3, q4);
  
      f = "S"; col = 12;
      i = (Integer)this.notentabelle.getValueAt(0, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q1 = new Kurs(i, 1, f);
      i = (Integer)this.notentabelle.getValueAt(1, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q2 = new Kurs(i, 2, f);
      i = (Integer)this.notentabelle.getValueAt(2, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q3 = new Kurs(i, 3, f);
      i = (Integer)this.notentabelle.getValueAt(3, col); if ((i == null) || (i.intValue() > 15) || (i.intValue() < 0)) i = Integer.valueOf(0);
      q4 = new Kurs(i, 4, f);
      this.verwaltung.sport.setKurseUsage(q1, q2, q3, q4);
  
      this.verwaltung.setzeAlleFaecher();
      this.verwaltung.belegungEinlesen();
  
      this.punkteLKDisplay.setText(this.verwaltung.lkBereich.toString());
      this.punkteGKDisplay.setText(this.verwaltung.gkBereich.toString());
  
      if (this.verwaltung.zuBelegendeBelegt) this.zuBelegendeBelegt.setText("Zu belegende Kurse belegt.");
      if (!this.verwaltung.zuBelegendeBelegt) this.zuBelegendeBelegt.setText("Zu belegende Kurse NICHT belegt.");
  
      if (this.verwaltung.qualifiziert.booleanValue())
      {
        this.qualifiziert.setText("Du bist qualifiziert.");
      }
      if (!this.verwaltung.qualifiziert.booleanValue())
      {
        this.qualifiziert.setText("Damit bist Du NOCH NICHT qualifiziert.");
      }
  
      ArrayList lk = this.verwaltung.setLK();
      Integer li = Integer.valueOf(0);
      Integer localInteger1;
      Integer localInteger2;
      for (Iterator i$ = lk.iterator(); i$.hasNext(); 
        localInteger2 = li = Integer.valueOf(li.intValue() + 1))
      {
        Fach l = (Fach)i$.next();
  
        this.ausgabetabelle.setValueAt(l.fachname, li.intValue(), 0);
        this.ausgabetabelle.setValueAt(l.eingebrachteQ, li.intValue(), 1);
        this.ausgabetabelle.setValueAt(l.gklk, li.intValue(), 2);
        this.ausgabetabelle.setValueAt(l.summeEndEingebrachte, li.intValue(), 3);
        localInteger1 = li;
      }
      ArrayList gk = this.verwaltung.setGK();
      Integer gi = Integer.valueOf(2);
      Integer localInteger3;
      Integer localInteger4;
      for (Iterator i$ = gk.iterator(); i$.hasNext(); 
        localInteger4 = gi = Integer.valueOf(gi.intValue() + 1))
      {
        Fach g = (Fach)i$.next();
  
        this.ausgabetabelle.setValueAt(g.fachname, gi.intValue(), 0);
        this.ausgabetabelle.setValueAt(g.eingebrachteQ, gi.intValue(), 1);
        this.ausgabetabelle.setValueAt(g.gklk, gi.intValue(), 2);
        this.ausgabetabelle.setValueAt(g.summeEndEingebrachte, gi.intValue(), 3);
        localInteger3 = gi;
      }
      int volleReihen = lk.size() + gk.size();
      int lassLeer = 13 - volleReihen;
      Integer localInteger5;
      for (int ind = volleReihen; i.intValue() < lassLeer; localInteger5 = i = Integer.valueOf(i.intValue() + 1))
      {
        this.ausgabetabelle.setValueAt("", ind, 0);
        this.ausgabetabelle.setValueAt("", ind, 1);
        this.ausgabetabelle.setValueAt("", ind, 2);
        this.ausgabetabelle.setValueAt("", ind, 3);
  
        localInteger4 = i;
      }
    }
  
    private void NotenFocusGained(FocusEvent evt)
    {
      notentabelleAktionen();
    }
  
    private void pruefungFocusGained(FocusEvent evt)
    {
      notentabelleAktionen();
      bestanden(); zugelassen();
    }
  
    private void KurseFocusLost(FocusEvent evt)
    {
      notentabelleAktionen();
      bestanden(); zugelassen();
    }
  
    private void note1ComboActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      String s = (String)this.note1Combo.getSelectedItem();
      this.verwaltung.ersteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note1ComboActionPerformed()
    {
      bestanden(); zugelassen();
      String s = (String)this.note1Combo.getSelectedItem();
      this.verwaltung.ersteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void nachpruef1ActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      this.verwaltung.nachpruefung1 = this.nachpruef1.isSelected();
      bestanden(); zugelassen();
    }
  
    private void nachpruef1ActionPerformed() {
      bestanden(); zugelassen();
      this.verwaltung.nachpruefung1 = this.nachpruef1.isSelected();
      bestanden(); zugelassen();
    }
  
    private void nach1ComboActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      String s = (String)this.nach1Combo.getSelectedItem();
      this.verwaltung.ersteNoteNachpruefung = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void nach1ComboActionPerformed()
    {
      bestanden(); zugelassen();
      String s = (String)this.nach1Combo.getSelectedItem();
      this.verwaltung.ersteNoteNachpruefung = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note2ComboActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      String s = (String)this.note2Combo.getSelectedItem();
      this.verwaltung.zweiteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note2ComboActionPerformed()
    {
      bestanden(); zugelassen();
      String s = (String)this.note2Combo.getSelectedItem();
      this.verwaltung.zweiteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void nachpruef2ActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      this.verwaltung.nachpruefung2 = this.nachpruef2.isSelected();
      bestanden(); zugelassen();
    }
  
    private void nachpruef2ActionPerformed() {
      bestanden(); zugelassen();
      this.verwaltung.nachpruefung2 = this.nachpruef2.isSelected();
      bestanden(); zugelassen();
    }
  
    private void nachpruef3ActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      this.verwaltung.nachpruefung3 = this.nachpruef3.isSelected();
      bestanden(); zugelassen();
    }
  
    private void nach2ComboActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      String s = (String)this.nach2Combo.getSelectedItem();
      this.verwaltung.zweiteNoteNachpruefung = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void nach2ComboActionPerformed() {
      bestanden(); zugelassen();
      String s = (String)this.nach2Combo.getSelectedItem();
      this.verwaltung.zweiteNoteNachpruefung = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note3ComboActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      String s = (String)this.note3Combo.getSelectedItem();
      this.verwaltung.dritteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note3ComboActionPerformed()
    {
      bestanden(); zugelassen();
      String s = (String)this.note3Combo.getSelectedItem();
      this.verwaltung.dritteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void nachpruef3ActionPerformed()
    {
      bestanden(); zugelassen();
      this.verwaltung.nachpruefung3 = this.nachpruef3.isSelected();
      bestanden(); zugelassen();
    }
  
    private void nach3ComboActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      String s = (String)this.nach3Combo.getSelectedItem();
      this.verwaltung.dritteNoteNachpruefung = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void nach3ComboActionPerformed() {
      bestanden(); zugelassen();
      String s = (String)this.nach3Combo.getSelectedItem();
      this.verwaltung.dritteNoteNachpruefung = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note4ComboActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      String s = (String)this.note4Combo.getSelectedItem();
      this.verwaltung.vierteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note4ComboActionPerformed()
    {
      bestanden(); zugelassen();
      String s = (String)this.note4Combo.getSelectedItem();
      this.verwaltung.vierteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note5ComboActionPerformed(ActionEvent evt)
    {
      bestanden(); zugelassen();
      String s = (String)this.note5Combo.getSelectedItem();
      this.verwaltung.fünfteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void note5ComboActionPerformed()
    {
      bestanden(); zugelassen();
      String s = (String)this.note5Combo.getSelectedItem();
      this.verwaltung.fünfteNote = Integer.valueOf(Integer.parseInt(s));
      bestanden(); zugelassen();
    }
  
    private void bestanden()
    {
      Integer abipunkte = this.verwaltung.setAbiPunktzahl();
      this.abipunktzahl.setText(abipunkte.toString());
      Integer punkte = this.verwaltung.setGesamtPunktzahl();
      this.gesamtpunktzahl.setText(punkte.toString());
      String durchschnitt = this.verwaltung.setDurchschnittsnote();
      this.durchschnittsnote.setText(durchschnitt);
      if ((!this.verwaltung.abiUeber5) || (!this.verwaltung.qualifiziert.booleanValue()) || (abipunkte.intValue() < 100) || (this.verwaltung.ersteNote.intValue() == 0) || (this.verwaltung.zweiteNote.intValue() == 0) || (this.verwaltung.dritteNote.intValue() == 0) || (this.verwaltung.vierteNote.intValue() == 0) || (this.verwaltung.fünfteNote.intValue() == 0))
      {
        this.bestanden.setText("Du hast nicht bestanden.");
      }
      else this.bestanden.setText("Du hast bestanden.");
    }
  
    private void zugelassen()
    {
      if ((this.verwaltung.qualifiziert.booleanValue()) && (this.verwaltung.abiKombiErlaubt()))
      {
        this.zugelassen.setText("Du bist zugelassen.");
      }
      if ((!this.verwaltung.qualifiziert.booleanValue()) || (!this.verwaltung.abiKombiErlaubt()))
      {
        this.zugelassen.setText("Du bist nicht zugelassen.");
        this.bestanden.setText("Du hast nicht bestanden.");
      }
    }
  
    private void pruefungstabAktionen()
    {
      note1ComboActionPerformed();
      nachpruef1ActionPerformed();
      nach1ComboActionPerformed();
      note2ComboActionPerformed();
      nachpruef2ActionPerformed();
      nach2ComboActionPerformed();
      note3ComboActionPerformed();
      nachpruef3ActionPerformed();
      nach3ComboActionPerformed();
      note4ComboActionPerformed();
      note5ComboActionPerformed();
    }
  
    private void setKursdaten()
    {
      try{
    	this.kd.comboLK = ((String)this.comboLK.getSelectedItem());
      this.kd.comboTW = ((String)this.comboTW.getSelectedItem());
      this.kd.comboFach3 = ((String)this.comboFach3.getSelectedItem());
      this.kd.comboFach4 = ((String)this.comboFach4.getSelectedItem());
      this.kd.comboFach5 = ((String)this.comboFach5.getSelectedItem());
      this.kd.checkboxKunst = Boolean.valueOf(this.checkboxKunst.isSelected());
      this.kd.checkboxFranz = Boolean.valueOf(this.checkboxFranz.isSelected());
      this.kd.radioTWGQ1 = Boolean.valueOf(this.radioTWGQ1.isSelected());
      this.kd.radioTWGQ2 = Boolean.valueOf(this.radioTWGQ2.isSelected());
      this.kd.radioTWGQ3 = Boolean.valueOf(this.radioTWGQ3.isSelected());
      this.kd.radioTWGQ4 = Boolean.valueOf(this.radioTWGQ4.isSelected());
      }catch(Exception e){}
    }
  
    private void getKursdaten() {
      this.comboLK.setSelectedItem(this.kd.comboLK);
      this.comboTW.setSelectedItem(this.kd.comboTW);
      this.comboFach3.setSelectedItem(this.kd.comboFach3);
      this.comboFach4.setSelectedItem(this.kd.comboFach4);
      this.comboFach5.setSelectedItem(this.kd.comboFach5);
  
      if (this.kd.checkboxKunst.booleanValue()) this.checkboxKunst.doClick(1000);
      this.checkboxKunst.setSelected(this.kd.checkboxKunst.booleanValue());
  
      if (this.kd.checkboxFranz.booleanValue()) this.checkboxFranz.doClick();
      this.checkboxFranz.setSelected(this.kd.checkboxFranz.booleanValue());
  
      if (this.kd.radioTWGQ1.booleanValue()) this.radioTWGQ1.doClick();
      this.radioTWGQ1.setSelected(this.kd.radioTWGQ1.booleanValue());
  
      if (this.kd.radioTWGQ2.booleanValue()) this.radioTWGQ2.doClick();
      this.radioTWGQ2.setSelected(this.kd.radioTWGQ2.booleanValue());
  
      if (this.kd.radioTWGQ3.booleanValue()) this.radioTWGQ3.doClick();
      this.radioTWGQ3.setSelected(this.kd.radioTWGQ3.booleanValue());
  
      if (this.kd.radioTWGQ4.booleanValue()) this.radioTWGQ4.doClick();
      this.radioTWGQ4.setSelected(this.kd.radioTWGQ4.booleanValue());
  
      kurstabAktionen();
    }
  
    private void setNotendaten()
    {
      int col = 1;
      this.kd.d1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.d2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.d3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.d4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 2;
      this.kd.e1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.e2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.e3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.e4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 3;
      this.kd.f1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.f2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.f3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.f4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 4;
      this.kd.k1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.k2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.k3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.k4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 6;
      this.kd.p1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.p2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.p3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.p4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 7;
      this.kd.g1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.g2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.g3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.g4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 8;
      this.kd.r1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.r2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.r3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.r4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 9;
      this.kd.m1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.m2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.m3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.m4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 10;
      this.kd.n1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.n2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.n3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.n4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 11;
      this.kd.t1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.t2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.t3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.t4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 0;
      this.kd.tw1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.tw2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.tw3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.tw4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 5;
      this.kd.twg1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.twg2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.twg3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.twg4 = ((Integer)this.notentabelle.getValueAt(3, col));
  
      col = 12;
      this.kd.s1 = ((Integer)this.notentabelle.getValueAt(0, col));
      this.kd.s2 = ((Integer)this.notentabelle.getValueAt(1, col));
      this.kd.s3 = ((Integer)this.notentabelle.getValueAt(2, col));
      this.kd.s4 = ((Integer)this.notentabelle.getValueAt(3, col));
    }
  
    public void getNotendaten()
    {
      int col = 1;
      this.notentabelle.setValueAt(this.kd.d1, 0, col);
      this.notentabelle.setValueAt(this.kd.d2, 1, col);
      this.notentabelle.setValueAt(this.kd.d3, 2, col);
      this.notentabelle.setValueAt(this.kd.d4, 3, col);
  
      col = 2;
      this.notentabelle.setValueAt(this.kd.e1, 0, col);
      this.notentabelle.setValueAt(this.kd.e2, 1, col);
      this.notentabelle.setValueAt(this.kd.e3, 2, col);
      this.notentabelle.setValueAt(this.kd.e4, 3, col);
  
      col = 3;
      this.notentabelle.setValueAt(this.kd.f1, 0, col);
      this.notentabelle.setValueAt(this.kd.f2, 1, col);
      this.notentabelle.setValueAt(this.kd.f3, 2, col);
      this.notentabelle.setValueAt(this.kd.f4, 3, col);
  
      col = 4;
      this.notentabelle.setValueAt(this.kd.k1, 0, col);
      this.notentabelle.setValueAt(this.kd.k2, 1, col);
      this.notentabelle.setValueAt(this.kd.k3, 2, col);
      this.notentabelle.setValueAt(this.kd.k4, 3, col);
  
      col = 6;
      this.notentabelle.setValueAt(this.kd.p1, 0, col);
      this.notentabelle.setValueAt(this.kd.p2, 1, col);
      this.notentabelle.setValueAt(this.kd.p3, 2, col);
      this.notentabelle.setValueAt(this.kd.p4, 3, col);
  
      col = 7;
      this.notentabelle.setValueAt(this.kd.g1, 0, col);
      this.notentabelle.setValueAt(this.kd.g2, 1, col);
      this.notentabelle.setValueAt(this.kd.g3, 2, col);
      this.notentabelle.setValueAt(this.kd.g4, 3, col);
  
      col = 8;
      this.notentabelle.setValueAt(this.kd.r1, 0, col);
      this.notentabelle.setValueAt(this.kd.r2, 1, col);
      this.notentabelle.setValueAt(this.kd.r3, 2, col);
      this.notentabelle.setValueAt(this.kd.r4, 3, col);
  
      col = 9;
      this.notentabelle.setValueAt(this.kd.m1, 0, col);
      this.notentabelle.setValueAt(this.kd.m2, 1, col);
      this.notentabelle.setValueAt(this.kd.m3, 2, col);
      this.notentabelle.setValueAt(this.kd.m4, 3, col);
  
      col = 10;
      this.notentabelle.setValueAt(this.kd.n1, 0, col);
      this.notentabelle.setValueAt(this.kd.n2, 1, col);
      this.notentabelle.setValueAt(this.kd.n3, 2, col);
      this.notentabelle.setValueAt(this.kd.n1, 3, col);
  
      col = 11;
      this.notentabelle.setValueAt(this.kd.t1, 0, col);
      this.notentabelle.setValueAt(this.kd.t2, 1, col);
      this.notentabelle.setValueAt(this.kd.t3, 2, col);
      this.notentabelle.setValueAt(this.kd.t4, 3, col);
  
      col = 0;
      this.notentabelle.setValueAt(this.kd.tw1, 0, col);
      this.notentabelle.setValueAt(this.kd.tw2, 1, col);
      this.notentabelle.setValueAt(this.kd.tw3, 2, col);
      this.notentabelle.setValueAt(this.kd.tw4, 3, col);
  
      col = 5;
      this.notentabelle.setValueAt(this.kd.twg1, 0, col);
      this.notentabelle.setValueAt(this.kd.twg2, 1, col);
      this.notentabelle.setValueAt(this.kd.twg3, 2, col);
      this.notentabelle.setValueAt(this.kd.twg4, 3, col);
  
      col = 12;
      this.notentabelle.setValueAt(this.kd.s1, 0, col);
      this.notentabelle.setValueAt(this.kd.s2, 1, col);
      this.notentabelle.setValueAt(this.kd.s3, 2, col);
      this.notentabelle.setValueAt(this.kd.s4, 3, col);
  
      notentabelleAktionen();
    }
  
    public void setPruefungsdaten()
    {
      this.kd.note1Combo = ((String)this.note1Combo.getSelectedItem());
      this.kd.note2Combo = ((String)this.note2Combo.getSelectedItem());
      this.kd.note3Combo = ((String)this.note3Combo.getSelectedItem());
      this.kd.note4Combo = ((String)this.note4Combo.getSelectedItem());
      this.kd.note5Combo = ((String)this.note5Combo.getSelectedItem());
  
      this.kd.nachpruefung1 = Boolean.valueOf(this.nachpruef1.isSelected());
      this.kd.nachpruefung2 = Boolean.valueOf(this.nachpruef2.isSelected());
      this.kd.nachpruefung3 = Boolean.valueOf(this.nachpruef3.isSelected());
  
      this.kd.nach1Combo = ((String)this.nach1Combo.getSelectedItem());
      this.kd.nach2Combo = ((String)this.nach2Combo.getSelectedItem());
      this.kd.nach3Combo = ((String)this.nach3Combo.getSelectedItem());
    }
  
    public void getPruefungsdaten() {
      this.note1Combo.setSelectedItem(this.kd.note1Combo);
      this.note2Combo.setSelectedItem(this.kd.note2Combo);
      this.note3Combo.setSelectedItem(this.kd.note3Combo);
      this.note4Combo.setSelectedItem(this.kd.note4Combo);
      this.note5Combo.setSelectedItem(this.kd.note5Combo);
  
      if (this.kd.nachpruefung1.booleanValue()) this.nachpruef1.doClick();
      this.nachpruef1.setSelected(this.kd.nachpruefung1.booleanValue());
  
      if (this.kd.nachpruefung2.booleanValue()) this.nachpruef2.doClick();
      this.nachpruef2.setSelected(this.kd.nachpruefung2.booleanValue());
  
      if (this.kd.nachpruefung3.booleanValue()) this.nachpruef3.doClick();
      this.nachpruef3.setSelected(this.kd.nachpruefung3.booleanValue());
  
      this.nach1Combo.setSelectedItem(this.kd.nach1Combo);
      this.nach2Combo.setSelectedItem(this.kd.nach2Combo);
      this.nach3Combo.setSelectedItem(this.kd.nach3Combo);
  
      pruefungstabAktionen();
    }
  
    public static void main(String[] args)
    {
      try
      {
        for (UIManager.LookAndFeelInfo info : UIManager.getInstalledLookAndFeels())
          if ("Nimbus".equals(info.getName())) {
            UIManager.setLookAndFeel(info.getClassName());
            break;
          }
      }
      catch (ClassNotFoundException ex) {
        Logger.getLogger(Abirechner.class.getName()).log(Level.SEVERE, null, ex);
      } catch (InstantiationException ex) {
        Logger.getLogger(Abirechner.class.getName()).log(Level.SEVERE, null, ex);
      } catch (IllegalAccessException ex) {
        Logger.getLogger(Abirechner.class.getName()).log(Level.SEVERE, null, ex);
      } catch (UnsupportedLookAndFeelException ex) {
        Logger.getLogger(Abirechner.class.getName()).log(Level.SEVERE, null, ex);
      }
  
      EventQueue.invokeLater(new Runnable()
      {
        public void run() {
          new Abirechner().setVisible(true);
        }
      });
    }
  }

