/*
 * Abiturrechner der GTS Offenbach
 * Copyright (C) 2013  Sabine Bergmann
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 * */
  
  import java.util.ArrayList;
  
  public class Fach
  {
    public Kurs q1 = new Kurs(Integer.valueOf(0), 1);
    public Kurs q2 = new Kurs(Integer.valueOf(0), 2);
    public Kurs q3 = new Kurs(Integer.valueOf(0), 3);
    public Kurs q4 = new Kurs(Integer.valueOf(0), 4);
    public ArrayList<Kurs> alleKurse = new ArrayList(4);
  
    public ArrayList<Kurs> belegteKurse = new ArrayList(4);
    public ArrayList<Kurs> eingebrachteKurse = new ArrayList(4);
    public ArrayList<Kurs> freieKurse = new ArrayList(4);
  
    public boolean isZuBeleg = false;
    public boolean isLk = false;
    public boolean isAbiGk = false;
    public int mussBeleg = 0;
    public int mussEinbring = 0;
    public String fachname;
    public boolean twg = false;
    public int twgchoice = 0;
  
    public ArrayList<Kurs> endEingebrachte = new ArrayList();
    public Integer summeEndEingebrachte = Integer.valueOf(0);
    public String eingebrachteQ = "";
    public String gklk = "";
  
    private void setAlleKurse()
    {
      if (this.alleKurse.size() >= 1) this.alleKurse.set(0, this.q1); else
        this.alleKurse.add(this.q1);
      if (this.fachname.equals("TWG"))
      {
        if (this.twgchoice == 1)
        {
          if (this.q1.note.intValue() > 0) this.twg = true; else
            this.twg = false;
        }
        if (this.twgchoice == 2)
        {
          if (this.q2.note.intValue() > 0) this.twg = true; else {
            this.twg = false;
          }
        }
      }
      if (this.alleKurse.size() >= 2) this.alleKurse.set(1, this.q2); else {
        this.alleKurse.add(this.q2);
      }
      if (this.alleKurse.size() >= 3) this.alleKurse.set(2, this.q3); else {
        this.alleKurse.add(this.q1);
      }
      if (this.alleKurse.size() >= 4) this.alleKurse.set(3, this.q4); else
        this.alleKurse.add(this.q2);
    }
  
    public ArrayList<Kurs> setBelegteKurse()
    {
      if (this.isZuBeleg)
      {
        this.belegteKurse.clear();
        for (int i = 0; i < this.alleKurse.size(); i++)
        {
          Kurs k = (Kurs)this.alleKurse.get(i);
          if (k.note.intValue() > 0) this.belegteKurse.add(k);
        }
        sortiereKurse(this.belegteKurse);
      }
      return this.belegteKurse;
    }
  
    public ArrayList<Kurs> setEingebrachteKurse()
    {
      if (this.isZuBeleg)
      {
        ArrayList belegt = setBelegteKurse();
  
        this.eingebrachteKurse.clear();
  
        if (this.mussEinbring > 0)
        {
          int counter = belegt.size() - this.mussEinbring;
          if (counter < 0) counter = 0;
  
          if (counter < belegt.size()) this.eingebrachteKurse.addAll(belegt.subList(counter, belegt.size()));
        }
  
        if (((this.fachname.equals("G")) && (!this.isAbiGk)) || (this.fachname.equals("F")))
        {
          this.eingebrachteKurse.clear();
          if (((Kurs)this.alleKurse.get(2)).note.intValue() > 0) this.eingebrachteKurse.add(this.alleKurse.get(2));
          if (((Kurs)this.alleKurse.get(3)).note.intValue() > 0) this.eingebrachteKurse.add(this.alleKurse.get(3));
  
        }
  
        if ((this.fachname.equals("TWG")) && (this.mussEinbring == 2))
        {
          this.eingebrachteKurse.clear();
          for (int i = 0; i < this.belegteKurse.size(); i++)
          {
            if (((Kurs)this.belegteKurse.get(i)).q.intValue() != this.twgchoice)
            {
              this.eingebrachteKurse.add(this.belegteKurse.get(i));
            }
  
            if (this.eingebrachteKurse.size() > 2)
            {
              sortiereKurse(this.eingebrachteKurse);
              this.eingebrachteKurse.remove(0);
            }
          }
        }
  
        sortiereKurse(this.eingebrachteKurse);
      }
  
      return this.eingebrachteKurse;
    }
  
    public void setFreieKurse(ArrayList<Kurs> eingebracht)
    {
      if (this.isZuBeleg)
      {
        this.freieKurse.clear();
        ArrayList belegt = this.belegteKurse;
  
        int counter = belegt.size() - eingebracht.size();
        if (counter > 0)
        {
          this.freieKurse.addAll(belegt.subList(0, counter));
        }
  
        sortiereKurse(this.freieKurse);
  
        if (this.fachname.equals("S"))
        {
          int lang = this.freieKurse.size();
          if (lang > 3) this.freieKurse.remove(0);
        }
  
        if (this.fachname.equals("TWG"))
        {
          if (this.mussEinbring == 0)
          {
            int lang = this.freieKurse.size();
            if (lang == 4)
            {
              this.freieKurse.remove(0);
              this.freieKurse.remove(0);
            }
            if (lang == 3) this.freieKurse.remove(0);
          }
          if (this.mussEinbring == 2) this.freieKurse.clear();
        }
  
        if (((this.fachname.equals("G")) && (!this.isAbiGk)) || (this.fachname.equals("F")))
        {
          this.freieKurse.clear();
          if (((Kurs)this.alleKurse.get(0)).note.intValue() > 0) this.freieKurse.add(this.alleKurse.get(0));
          if (((Kurs)this.alleKurse.get(1)).note.intValue() > 0) this.freieKurse.add(this.alleKurse.get(1));
        }
  
        sortiereKurse(this.freieKurse);
      }
    }
  
    public void setKurseUsage()
    {
      setAlleKurse();
      setBelegteKurse();
      setEingebrachteKurse();
      setFreieKurse(setEingebrachteKurse());
      setEndEingebrachte();
    }
  
    public void setKurseUsage(Kurs q1, Kurs q2, Kurs q3, Kurs q4) {
      this.q1 = q1; this.q2 = q2; this.q3 = q3; this.q4 = q4;
      setAlleKurse();
      setBelegteKurse();
      setEingebrachteKurse();
      setFreieKurse(setEingebrachteKurse());
      setEndEingebrachte();
    }
  
    public void setEndEingebrachte()
    {
      this.endEingebrachte.clear();
      this.endEingebrachte.addAll(this.eingebrachteKurse);
      sortiereKurseQ(this.endEingebrachte);
  
      this.summeEndEingebrachte = Integer.valueOf(0);
      Integer i = Integer.valueOf(0);
      for (Kurs k : this.endEingebrachte)
      {
        i = Integer.valueOf(i.intValue() + k.note.intValue());
      }
      this.summeEndEingebrachte = i;
  
      this.eingebrachteQ = "";
      for (Kurs k : this.endEingebrachte)
      {
        this.eingebrachteQ += k.q.toString();
        this.eingebrachteQ += " ";
      }
  
      if (this.isLk) this.gklk = "JA";
      if (!this.isLk) this.gklk = "NEIN"; 
    }
  
    public void setEndEingebrachte(Kurs k)
    {
      this.endEingebrachte.add(k);
      sortiereKurseQ(this.endEingebrachte);
  
      this.summeEndEingebrachte = Integer.valueOf(0);
      Integer i = Integer.valueOf(0);
      for (Kurs kurs : this.endEingebrachte)
      {
        i = Integer.valueOf(i.intValue() + kurs.note.intValue());
      }
      this.summeEndEingebrachte = i;
  
      this.eingebrachteQ = "";
      for (Kurs kurs : this.endEingebrachte)
      {
        this.eingebrachteQ += kurs.q.toString();
        this.eingebrachteQ += " ";
      }
    }
  
    public ArrayList<Kurs> sortiereKurse(ArrayList<Kurs> liste)
    {
      for (int i = 1; i < liste.size(); i++)
      {
        int j = i;
        while ((j > 0) && (((Kurs)liste.get(j)).note.compareTo(((Kurs)liste.get(j - 1)).note) < 0))
        {
          Kurs temp = (Kurs)liste.get(j - 1);
          liste.set(j - 1, liste.get(j));
          liste.set(j, temp);
          j--;
        }
      }
      return liste;
    }
  
    public ArrayList<Kurs> sortiereKurseQ(ArrayList<Kurs> liste)
    {
      for (int i = 1; i < liste.size(); i++)
      {
        int j = i;
        while ((j > 0) && (((Kurs)liste.get(j)).q.compareTo(((Kurs)liste.get(j - 1)).q) < 0))
        {
          Kurs temp = (Kurs)liste.get(j - 1);
          liste.set(j - 1, liste.get(j));
          liste.set(j, temp);
          j--;
        }
      }
      return liste;
    }
  }
